/**
 * FontCellRenderer.java
 * Created by Stijn Strickx on May 7, 2008
 */


import java.awt.Component;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

public class FontCellRenderer extends DefaultTreeCellRenderer{

    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object o, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        super.getTreeCellRendererComponent(tree,o,selected,expanded,leaf,row,hasFocus);
        if(o instanceof StyledFont){
            setText(((StyledFont)o).toString());
        }
        else if(o instanceof Font){
            setIcon(new FontIcon((Font)o));
            setText(((Font)o).getFontName());
        }
        else if(o instanceof GraphicsEnvironment){
            setText("Fonts");
        }
        return this;
    }
}