/**
 * FontIcon.java
 * Created by Stijn Strickx on May 7, 2008
 */

import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import javax.swing.Icon;

class FontIcon implements Icon{
    
    private Font font;
    private int size;

    public FontIcon(Font font){
        this.font = font;
        size = 25;
    }

    public void paintIcon(Component c, Graphics g, int x, int y) {
        Font defaultFont = g.getFont();
        g.setFont(font.deriveFont(15f));
        g.drawString("A", x, y+(size)*3/4);
        g.setFont(defaultFont);
    }

    public int getIconWidth() {
        return size;
    }

    public int getIconHeight() {
        return size;
    }

}