/**
 * FontTreeListener.java
 * Created by Stijn Strickx on May 7, 2008
 */

import java.awt.Font;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;

class FontTreeListener implements TreeSelectionListener{
    
    private JLabel fontLabel;

    public FontTreeListener(JLabel fontLabel) {
        this.fontLabel = fontLabel;
    }

    public void valueChanged(TreeSelectionEvent e) {
        TreePath path = ((JTree)e.getSource()).getSelectionPath();
        if(!(path == null) && (path.getLastPathComponent() instanceof Font)){
            Font value = (Font)path.getLastPathComponent();
            fontLabel.setFont(value.deriveFont(25f));
            fontLabel.setText(value.getFontName());
        }
    }
}