/**
 * FontTreeModel.java
 * Created by Stijn Strickx on May 7, 2008
 */

import java.awt.Font;
import java.awt.GraphicsEnvironment;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

public class FontTreeModel implements TreeModel{
    
    private Font[] fonts;
    private int[] styles;
    
    public FontTreeModel(){
        fonts  = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
        styles = new int[4];
        styles[0] = Font.PLAIN;
        styles[1] = Font.BOLD;
        styles[2] = Font.ITALIC;
        styles[3] = Font.BOLD+Font.ITALIC;
    }

    public Object getRoot() {
        return GraphicsEnvironment.getLocalGraphicsEnvironment();
    }

    public Object getChild(Object o, int i) {
        if(o instanceof GraphicsEnvironment){
            return fonts[i];
        }
        else{
            return new StyledFont(((Font)o).getName(),styles[i],10);  
        }
    }

    public int getChildCount(Object o) {
        if(o instanceof GraphicsEnvironment){
            return fonts.length;
        }
        else{
            return styles.length;
        }
    }

    public boolean isLeaf(Object o) {
        return !(o instanceof GraphicsEnvironment || (!(o instanceof StyledFont) && o instanceof Font));
    }

    public void valueForPathChanged(TreePath t, Object o) {
        //
    }

    public int getIndexOfChild(Object o1, Object o2) {
        int index = 0;
        if(o1 instanceof GraphicsEnvironment){
            for(int i=0;i<fonts.length;i++){
                if(fonts[i].equals(o2)){
                    index = i;
                }
            }
        }
        else{
            for(int i=0;i<styles.length;i++){
                if(styles[i] == ((StyledFont)o2).getStyle()){
                    index = i;
                }
            }
        }
        return index;
    }

    public void addTreeModelListener(TreeModelListener arg0) {
        //
    }

    public void removeTreeModelListener(TreeModelListener arg0) {
        //
    }

}